/*
 * File:		RS485.c
 * Purpose:		The basic example
 *
 *              Configures GPIO for the TxD, RxD and RTS on the SQM4 EASY BOARD with SQM4_K70 
 *              
 *
 */


#define GPIO_PIN_MASK            0x1Fu
#define GPIO_PIN(x)              (((1)<<(x & GPIO_PIN_MASK)))
#define BITRATE      9600
#define TIMEBIT      (12000000/BITRATE)

#include "common.h"
#include "lptmr.h"

//Function declarations
void init_gpio(void);
void send_byte(unsigned char byte);
unsigned char receive_byte(void);
void bitwait(unsigned int time);

unsigned int bittime;
unsigned char schar=0xAA;
unsigned char tchar=0xAA;

/********************************************************************/

void main (void)
{
//	unsigned int counter=0;
	
  printf("\r\n\n************************************\n");
  printf("\r*** SQM4-K70F120M RS485 Example! ***\n");
  printf("\r************************************\n");

  /* Turn on all port clocks */
  SIM_SCGC5 = SIM_SCGC5_PORTA_MASK | SIM_SCGC5_PORTB_MASK | SIM_SCGC5_PORTC_MASK | SIM_SCGC5_PORTD_MASK | SIM_SCGC5_PORTE_MASK | SIM_SCGC5_PORTF_MASK;

  
  /* Initialize GPIO on SQM4 EASY BOARD-K70F120M */
  init_gpio();
	bittime=TIMEBIT;

  while(schar){
		send_byte(schar);
		send_byte(tchar);
		bitwait(10*bittime);
  }
	while(1){
		schar=receive_byte();
		printf("Received 0x%2x\r\n",schar);
	}
}

unsigned char receive_byte(void){
	unsigned char rchar=0;
	while(GPIOF_PDIR&=GPIO_PDDR_PDD(GPIO_PIN(19))){;}
	bitwait(3*bittime/2);
	if(GPIOF_PDIR&=GPIO_PDDR_PDD(GPIO_PIN(19))) rchar|=0x01;
	bitwait(bittime);
	if(GPIOF_PDIR&=GPIO_PDDR_PDD(GPIO_PIN(19))) rchar|=0x02;
	bitwait(bittime);
	if(GPIOF_PDIR&=GPIO_PDDR_PDD(GPIO_PIN(19))) rchar|=0x04;
	bitwait(bittime);
	if(GPIOF_PDIR&=GPIO_PDDR_PDD(GPIO_PIN(19))) rchar|=0x08;
	bitwait(bittime);
	if(GPIOF_PDIR&=GPIO_PDDR_PDD(GPIO_PIN(19))) rchar|=0x10;
	bitwait(bittime);
	if(GPIOF_PDIR&=GPIO_PDDR_PDD(GPIO_PIN(19))) rchar|=0x20;
	bitwait(bittime);
	if(GPIOF_PDIR&=GPIO_PDDR_PDD(GPIO_PIN(19))) rchar|=0x40;
	bitwait(bittime);
	if(GPIOF_PDIR&=GPIO_PDDR_PDD(GPIO_PIN(19))) rchar|=0x80;
	bitwait(bittime);
	return(rchar);
}

void bitwait(unsigned int bittime){
	volatile unsigned int time=bittime;
	while(time){time--;}
};

void send_byte(unsigned char byte){
  GPIOF_PDOR|=GPIO_PDOR_PDO(GPIO_PIN(21));           //RTS=1;

	GPIOF_PDOR&=~GPIO_PDOR_PDO(GPIO_PIN(20));           //Start bit
	bitwait(bittime);
	
	if(byte&0x01) GPIOF_PDOR|=GPIO_PDOR_PDO(GPIO_PIN(20));
	else GPIOF_PDOR&=~GPIO_PDOR_PDO(GPIO_PIN(20));
	bitwait(bittime);
	
	if(byte&0x02) GPIOF_PDOR|=GPIO_PDOR_PDO(GPIO_PIN(20));
	else GPIOF_PDOR&=~GPIO_PDOR_PDO(GPIO_PIN(20));
	bitwait(bittime);

	if(byte&0x04) GPIOF_PDOR|=GPIO_PDOR_PDO(GPIO_PIN(20));
	else GPIOF_PDOR&=~GPIO_PDOR_PDO(GPIO_PIN(20));
	bitwait(bittime);

	if(byte&0x08) GPIOF_PDOR|=GPIO_PDOR_PDO(GPIO_PIN(20));
	else GPIOF_PDOR&=~GPIO_PDOR_PDO(GPIO_PIN(20));
	bitwait(bittime);

	if(byte&0x10) GPIOF_PDOR|=GPIO_PDOR_PDO(GPIO_PIN(20));
	else GPIOF_PDOR&=~GPIO_PDOR_PDO(GPIO_PIN(20));
	bitwait(bittime);

	if(byte&0x20) GPIOF_PDOR|=GPIO_PDOR_PDO(GPIO_PIN(20));
	else GPIOF_PDOR&=~GPIO_PDOR_PDO(GPIO_PIN(20));
	bitwait(bittime);

	if(byte&0x40) GPIOF_PDOR|=GPIO_PDOR_PDO(GPIO_PIN(20));
	else GPIOF_PDOR&=~GPIO_PDOR_PDO(GPIO_PIN(20));
	bitwait(bittime);

	if(byte&0x80) GPIOF_PDOR|=GPIO_PDOR_PDO(GPIO_PIN(20));
	else GPIOF_PDOR&=~GPIO_PDOR_PDO(GPIO_PIN(20));
	bitwait(bittime);

	GPIOF_PDOR|=GPIO_PDOR_PDO(GPIO_PIN(20));             //Stop bit
	bitwait(bittime);
  GPIOF_PDOR&=~GPIO_PDOR_PDO(GPIO_PIN(21));            //RTS=0
}


// *                                                               
// * Initialize GPIO for RS485
// *

void init_gpio()
{
  //Set PTF19 (connected to RxD) for GPIO functionality
  PORTF_PCR19=(0|PORT_PCR_MUX(1));

  //Change PTF19 to intputs
  GPIOF_PDDR&=~GPIO_PDDR_PDD(GPIO_PIN(19));	

  //Set PTF20 (connected to TxD) for GPIO functionality
  PORTF_PCR20=(0|PORT_PCR_MUX(1));

  //Change PTF20 to outputs
  GPIOF_PDDR|=GPIO_PDDR_PDD(GPIO_PIN(20));	

  //Set PTF20 to 1 (TxD = 1)
  GPIOF_PDOR&=~GPIO_PDOR_PDO(GPIO_PIN(20));

  //Set PTF21 (connected to RTS) for GPIO functionality
  PORTF_PCR21=(0|PORT_PCR_MUX(1));

  //Change PTF21 to outputs
  GPIOF_PDDR|=GPIO_PDDR_PDD(GPIO_PIN(21));	

  //Set PTF21 to 1 (RTS = 0)
  GPIOF_PDOR&=~GPIO_PDOR_PDO(GPIO_PIN(21));
}

/********************************************************************/
