#include "common.h"
#include "dspi_common.h"

extern int int_spi_rfdf; 
extern int int_spi_rfof;

void dspi_config(int DSPI_COMMAND , dspi_ctl *dspi_value)
{
int  i=0,j=0;
uint32 pop_reg;
	
	
  switch(DSPI_COMMAND) 
  {
    case 0: // dspi ports enable
    break;
    
    case 1:	  //write enable
    SPI1_MCR = 0x80010001;
    SPI1_CTAR0 = (0x38000000 +dspi_value->br) | dspi_value->cpha | dspi_value->cpol;
    printf("SPI1_CTAR0 = %08X\n",SPI1_CTAR0);
    SPI1_PUSHR = 0x08010006;
    SPI1_MCR =  0x80010000 ; 
    printf("wait for eoqf bit to be set\n");
    while( SPI_SR_EOQF != (SPI1_SR & SPI_SR_EOQF));
    printf("eoqf bit is set\n");
    SPI1_MCR = 0x80010001;
    SPI1_SR = SPI1_SR | SPI_SR_EOQF | SPI_SR_TCF ;
    pop_reg = SPI1_POPR ;
    break;
	
    case 2: //sector erase
    SPI1_MCR = 0x80010001;
    SPI1_CTAR0 = (0x78000000 + dspi_value->br) | dspi_value->cpha | dspi_value->cpol;
    SPI1_PUSHR = 0x8001D800;
    SPI1_CTAR1 = (0x78000000 + dspi_value->br) | dspi_value->cpha | dspi_value->cpol;
    SPI1_PUSHR = 0x18010001;
    SPI1_MCR =  0x80010000; 
    printf("wait for eoqf bit to be set\n");
    while(SPI_SR_EOQF != (SPI1_SR & SPI_SR_EOQF))
    {}
    printf("eoqf bit is set\n");
    SPI1_SR = SPI1_SR | SPI_SR_TCF  | SPI_SR_EOQF ;
    pop_reg = SPI1_POPR ;
    pop_reg = SPI1_POPR ;
    break;
    
    case 3: //WAIT_WR_OVER
    pop_reg =0xA5;
    SPI1_MCR = 0x80010001;
    SPI1_CTAR0 = (0x78000000  + dspi_value->br) | dspi_value->cpha | dspi_value->cpol;
    while(pop_reg & 0x1)
    {
      SPI1_PUSHR = 0x08010500;
      SPI1_MCR =  0x80010000 ; 
      printf("wait for eoqf bit to be set\n");
      while( SPI_SR_EOQF != (SPI1_SR & SPI_SR_EOQF))
      {}
      printf("eoqf bit is set\n");
      SPI1_SR = SPI1_SR | SPI_SR_EOQF | SPI_SR_TCF ;
      SPI1_MCR = 0x80010001;
      pop_reg = SPI1_POPR ;
      printf("\n SR register value after WEN: %08X \n",pop_reg);
    }
    break;
    
    case 4:  //read SR register 
    SPI1_MCR = 0x80010001;
    SPI1_CTAR0 = (0x78000000 + dspi_value->br) | dspi_value->cpha | dspi_value->cpol;
    SPI1_PUSHR = 0x08010500;
    SPI1_MCR =  0x80010000 ; 
    while( SPI_SR_EOQF != (SPI1_SR & SPI_SR_EOQF))
    {}
    printf("eoqf bit is set\n");
    SPI1_SR = SPI1_SR | SPI_SR_EOQF | SPI_SR_TCF ;
    SPI1_MCR = 0x80010001;
    pop_reg = SPI1_POPR ;
    printf("\n SR register value: %08X \n",pop_reg);
    break;
    
    case 5 : 
    SPI1_MCR = 0x80010001;
    SPI1_CTAR0 = (0x78000000 + dspi_value->br) | dspi_value->cpha | dspi_value->cpol;
    do
    {
      SPI1_PUSHR = 0x08010500;
      SPI1_MCR =  0x80010000 ; 
      while( SPI_SR_EOQF != (SPI1_SR & SPI_SR_EOQF))
      {}
      SPI1_SR = SPI1_SR | SPI_SR_EOQF | SPI_SR_TCF ;
      pop_reg = SPI1_POPR ;
      //printf("\n SR register value after WEN: %08X \r\n",pop_reg);
    }while(!(pop_reg & 0x2));
    
    printf("WEL bit is set\n\n\n");
    break;
    
    case 6:  //write instruction to eeprom
    SPI1_MCR = 0x80010001;
    SPI1_CTAR0 = (0x78000000 + dspi_value->br) | dspi_value->cpha | dspi_value->cpol;
    SPI1_PUSHR = 0x80010200;
    SPI1_CTAR1 = (0x78000000 + dspi_value->br) | dspi_value->cpha | dspi_value->cpol;
    SPI1_PUSHR = 0x90010000;
    SPI1_PUSHR = 0x90010000 + dspi_value->txdata++;
    SPI1_PUSHR = 0x98010000 + dspi_value->txdata++; //4-fifo only
    SPI1_MCR =  0x80010000; //start transfer
    while(SPI_SR_EOQF != (SPI1_SR & SPI_SR_EOQF));
    SPI1_SR = SPI1_SR | SPI_SR_TCF  | SPI_SR_EOQF ;   
    SPI1_MCR =  0x80010001; // halt
    
    if(dspi_value->buffer ==1)
    {
      for(j=0;j<10;j++)
      {
        SPI1_PUSHR = 0x90010000 + dspi_value->txdata++;
        SPI1_PUSHR = 0x90010000 + dspi_value->txdata++;
        SPI1_PUSHR = 0x90010000 + dspi_value->txdata++;
        SPI1_PUSHR = 0x98010000 + dspi_value->txdata++;
        printf("\n DSPI SR register value: %08X \n",SPI1_SR);
        SPI1_MCR =  0x80010000; //start transfer
        while(SPI_SR_EOQF != (SPI1_SR & SPI_SR_EOQF));
        SPI1_SR = SPI1_SR | SPI_SR_TCF  | SPI_SR_EOQF ;   
        SPI1_MCR =  0x80010001; // halt            
      }
    }
    SPI1_CTAR0 = (0x78000000 + dspi_value->br) | dspi_value->cpha | dspi_value->cpol;
    SPI1_PUSHR = 0x08010000 + dspi_value->txdata; // total 43 word transferred.
   
    printf("\n DSPI SR register value: %08X \n",SPI1_SR);
    SPI1_MCR =  0x80010000; 
    while(SPI_SR_EOQF != (SPI1_SR & SPI_SR_EOQF))
    {}
    SPI1_SR = SPI1_SR | SPI_SR_TCF  | SPI_SR_EOQF ;
    SPI1_MCR =  0x80010001; // halt

    printf("\n DSPI SR register value: %08X \n",SPI1_SR);
    //Flush the RX FIFO
    SPI1_MCR |= 0x400;
    
    break;
    
    case 7://read flash
    SPI1_MCR = 0x80010C01; 
    SPI1_CTAR0 = (0x78000000 + dspi_value->br) | dspi_value->cpha | dspi_value->cpol | dspi_value->lsbfe;
    if(dspi_value->lsbfe)
    {
        SPI1_PUSHR = 0x800100C0; // 1st fifo
    }
    else
    {
        SPI1_PUSHR = 0x80010300; // 1st fifo
    }
    SPI1_CTAR1 = (0x78000000 + dspi_value->br) | dspi_value->cpha | dspi_value->cpol | dspi_value->lsbfe;
    SPI1_PUSHR = 0x90010000; // 2nd fifo
    SPI1_PUSHR = 0x90010000; // 3rd fifo
    SPI1_CTAR0 = (0x78000000 + dspi_value->br) | dspi_value->cpha | dspi_value->cpol | dspi_value->lsbfe;
    SPI1_PUSHR = 0x88010000; // 4th fifo, end of queue
    SPI1_MCR =  0x80010000;  // start transfer
    while(SPI_SR_EOQF != (SPI1_SR & SPI_SR_EOQF));
    SPI1_SR = SPI1_SR | SPI_SR_TCF  | SPI_SR_EOQF ;
    SPI1_MCR =  0x80010001; // halt
    pop_reg = SPI1_POPR ;  // dummy read
    pop_reg = SPI1_POPR ;  // dummy read
    
    pop_reg = SPI1_POPR ;
    printf("1st word: 0x%04x\r\n", pop_reg);
    pop_reg = SPI1_POPR ;
    printf("2nd word: 0x%04x\r\n", pop_reg);
    
    for(j=0;j<10;j++)
    {  
      SPI1_PUSHR = 0x90010000; // 1st dummy tx fifo
      SPI1_PUSHR = 0x90010000; // 2nd dummy tx fifo
      SPI1_PUSHR = 0x90010000; // 3rd dummy tx fifo
      SPI1_PUSHR = 0x98010000; // 4th dummy tx fifo
      SPI1_MCR =  0x80010000;  // start transfer
      while(SPI_SR_EOQF != (SPI1_SR & SPI_SR_EOQF));
      SPI1_SR = SPI1_SR | SPI_SR_TCF  | SPI_SR_EOQF ;
      SPI1_MCR =  0x80010001; // halt
      
      pop_reg = SPI1_POPR ;
      printf("0x%04x, ", pop_reg);
      pop_reg = SPI1_POPR ;
      printf("0x%04x, ", pop_reg);
      pop_reg = SPI1_POPR ;
      printf("0x%04x, ", pop_reg);
      pop_reg = SPI1_POPR ;
      printf("0x%04x\r\n", pop_reg);
    }
    SPI1_PUSHR = 0x18010000; // last dummy tx fifo
    SPI1_MCR =  0x80010000;  // start transfer
    while(SPI_SR_EOQF != (SPI1_SR & SPI_SR_EOQF));
    SPI1_SR = SPI1_SR | SPI_SR_TCF  | SPI_SR_EOQF ;
    SPI1_MCR =  0x80010001; // halt    
    pop_reg = SPI1_POPR ; // read 43th word.
    printf("0x%04x\r\n", pop_reg); 
    
    printf("\n DSPI SR register value: %08X \n",SPI1_SR);
    break; 
	
    case 8: //interrupt eoqf 
    SPI1_RSER = SPI_RSER_EOQF_RE;
    SPI1_MCR = 0x80010001;
    SPI1_CTAR0 = (0x38000000 +dspi_value->br) | dspi_value->cpha | dspi_value->cpol;
    SPI1_PUSHR = 0x08010006;
    SPI1_MCR =  0x80010000 ; 
    for(i=0;i<10;i++);
    printf("SPI1_SR = 0x%08x\r\n", SPI1_SR);
    SPI1_MCR = 0x80010001;
    SPI1_SR = SPI1_SR | SPI_SR_EOQF | SPI_SR_TCF ;
    pop_reg = SPI1_POPR ;
    break;
    
    case 9: //interrupt tcf 
    SPI1_RSER = SPI_RSER_TCF_RE;
    SPI1_MCR = 0x80010001;
    SPI1_CTAR0 = (0x38000000 +dspi_value->br) | dspi_value->cpha | dspi_value->cpol;
    SPI1_PUSHR = 0x08010006;
    SPI1_MCR =  0x80010000 ; 
    for(i=0;i<10;i++);
    SPI1_MCR = 0x80010001;
    SPI1_SR = SPI1_SR | SPI_SR_EOQF | SPI_SR_TCF ;
    pop_reg = SPI1_POPR ;
    break;
	
    case 10: //interrupt tfff 
    SPI1_RSER = SPI_RSER_TFFF_RE;
    SPI1_MCR = 0x80010001;
    SPI1_CTAR0 = (0x38000000 +dspi_value->br) | dspi_value->cpha | dspi_value->cpol;
    SPI1_PUSHR = 0x08010006;
    SPI1_MCR =  0x80010000 ; 
    for(i=0;i<10;i++); 
    SPI1_MCR = 0x80010001;
    SPI1_SR = SPI1_SR | SPI_SR_TFFF | SPI_SR_TCF ;
    pop_reg = SPI1_POPR ;
    break;
	
    case 11: //interrupt rfof
    SPI1_RSER = SPI_RSER_RFOF_RE;
    SPI1_MCR = 0x80010001;
    SPI1_CTAR0 = (0x38000000 +dspi_value->br) | dspi_value->cpha | dspi_value->cpol;
    SPI1_PUSHR = 0x08010006;
    SPI1_MCR &=  0xFFFFFFFE ; 
    while( SPI_SR_EOQF != (SPI1_SR & SPI_SR_EOQF));
    SPI1_MCR |= 0x00000001;
    SPI1_SR = SPI1_SR | SPI_SR_EOQF | SPI_SR_TCF ;
    
    SPI1_CTAR0 = (0x78000000 + dspi_value->br) | dspi_value->cpha | dspi_value->cpol;
    SPI1_PUSHR = 0x80010300; // 1
    SPI1_CTAR1 = (0x78000000 + dspi_value->br) | dspi_value->cpha | dspi_value->cpol;
    SPI1_PUSHR = 0x90010000; // 2
    
    SPI1_PUSHR = 0x90010000; // dummy push
    SPI1_PUSHR = 0x98010000; // dummy push, eoq
    SPI1_MCR &=  0xFFFFFFFE ;
    while(SPI_SR_EOQF != (SPI1_SR & SPI_SR_EOQF));
    SPI1_SR = SPI1_SR | SPI_SR_EOQF | SPI_SR_TCF ;    
    SPI1_MCR |= 0x00000001; // halt 

    for(j=0;j<10;j++) // full rx fifo and shift register
    {  
      if(dspi_value->buffer ==1)
      {
        for(i=0;i<3;i++)
        {
          SPI1_PUSHR = 0x90010000;
        }
        SPI1_PUSHR = 0x18010000; // 4, dummy push, eoq
      }
      SPI1_MCR &=  0xFFFFFFFE ; // start transfer
      for(i=0;i<100;i++);
      if(int_spi_rfof)
      {
        int_spi_rfof = 0;
        SPI1_RSER &= ~SPI_RSER_RFOF_RE;
        SPI1_MCR |= 0x400; // clear rx fifo
        break;
      }
      while(SPI_SR_EOQF != (SPI1_SR & SPI_SR_EOQF));
      SPI1_SR = SPI1_SR | SPI_SR_EOQF | SPI_SR_TCF ;    
      SPI1_MCR |= 0x00000001; // halt    
    }
    SPI1_PUSHR = 0x18010000; // last word
    while(SPI_SR_EOQF != (SPI1_SR & SPI_SR_EOQF));
    SPI1_SR = SPI1_SR | SPI_SR_EOQF | SPI_SR_TCF | SPI_SR_RFOF ;    
    SPI1_MCR |= 0x00000001; // halt
    SPI1_POPR; // pop last word
    break;
    
    case 12: //interrupt rfdf
    SPI1_RSER = SPI_RSER_RFDF_RE;
    SPI1_MCR = 0x80010001;
    SPI1_CTAR0 = (0x38000000 +dspi_value->br) | dspi_value->cpha | dspi_value->cpol;
    SPI1_PUSHR = 0x08010006;
    SPI1_MCR =  0x80010000 ; 
    
    while(!int_spi_rfdf);
    int_spi_rfdf = 0;
    printf("rfdf bit is set\n");
    
    SPI1_MCR = 0x80010001;
    SPI1_SR = SPI1_SR | SPI_SR_EOQF | SPI_SR_TCF ;
    break;
    
    case 13: //DMA tfff 
	
//	MCF_INTC0_IMRL = 0x80000000;
    
    SPI1_CTAR0 = (0x78000000 + dspi_value->br) | dspi_value->cpha | dspi_value->cpol;

    SPI1_RSER = SPI_RSER_TFFF_RE|SPI_RSER_TFFF_DIRS;
    
	SPI1_MCR = 0x80010001;
	
	break;
	
	case 14 : //DMA Rx
	
	//interrupt rfdf
	printf("entering RFDF DMA CONFIG\n");
	
//	MCF_INTC0_IMRL = 0x80000000;
	
//	MCF_INTC1_IMRH = 0x00000080;
 
     
    //
    SPI1_MCR = 0x80010001; 
    
    SPI1_CTAR0 = (0x78000000 + dspi_value->br) | dspi_value->cpha | dspi_value->cpol;

    SPI1_PUSHR = 0x80010300;
    
    SPI1_CTAR1 = (0x78000000 + dspi_value->br) | dspi_value->cpha | dspi_value->cpol;

    SPI1_PUSHR = 0x90010000;
    
    if(dspi_value->buffer ==1)
    {
         
    for(i=0;i<13;i++)
    
    SPI1_PUSHR = 0x90010000;
    
    }
       
    SPI1_CTAR0 = (0x78000000 + dspi_value->br) | dspi_value->cpha | dspi_value->cpol;

    SPI1_PUSHR = 0x08010000;
    
    SPI1_MCR =  0x80010000; 

    printf("wait for eoqf bit to be set\n");

    while(SPI_SR_EOQF != (SPI1_SR & SPI_SR_EOQF))
    {}
    
    printf("eoqf bit is set\n");
    
    SPI1_SR = SPI1_SR | SPI_SR_TCF  | SPI_SR_EOQF ;
    
    printf("\n DSPI SR register value: %08X \n",SPI1_SR);
    
    SPI1_RSER = SPI_RSER_RFDF_RE|SPI_RSER_RFDF_DIRS;
	
	break;
	
	case 15: //stop mode
	
    SPI1_MCR = 0x80010001;
    
    SPI1_CTAR0 = (0x38000000 +dspi_value->br) | dspi_value->cpha | dspi_value->cpol;
  
    SPI1_PUSHR = 0x08010006;
    
   
    printf("wake up mechanism wworking correctly%08X \n",SPI1_TCR);

   

    printf("wait for eoqf bit to be set\n");
    
   
     /*temp code for dual chip env*/
   /*commentin it only for regression setup
    printf("Enter Stop Mode");
    LJ_TRIGGER_SET1();
    SPI_MCR =  0x80010000;
    i = SPI_TCR ;
    asm( STOP   #0x2000);*/
    /******************************/
    if(SPI1_TCR == i+0x00010000)
    printf("wake up mechanism wworking correctly%08X \n",SPI1_TCR);
    else
    printf("wake up mechanism not working correctly%08X \n",SPI1_TCR);
    
    /*****************************/
     printf("wait for eoqf bit to be set\n");

    while( SPI_SR_EOQF != (SPI1_SR & SPI_SR_EOQF))
    {}

    printf("eoqf bit is set\n");
    
    SPI1_MCR = 0x80010001;

    SPI1_SR = SPI1_SR | SPI_SR_EOQF | SPI_SR_TCF ;
 
    pop_reg = SPI1_POPR ;
		       
    break;
    case 16: // modify format read flash
    SPI1_MCR = 0x84010101; 
    SPI1_CTAR0 = (0x78000000 + dspi_value->br) | dspi_value->cpha | dspi_value->cpol;
    SPI1_PUSHR = 0x80010300; // 1st fifo
    SPI1_CTAR1 = (0x78000000 + dspi_value->br) | dspi_value->cpha | dspi_value->cpol;
    SPI1_PUSHR = 0x90010000; // 2nd fifo
    SPI1_PUSHR = 0x90010000; // 3rd fifo
    SPI1_CTAR0 = (0x78000000 + dspi_value->br) | dspi_value->cpha | dspi_value->cpol;
    SPI1_PUSHR = 0x88010000; // 4th fifo, end of queue
    SPI1_MCR &=  0xfffffffe;  // start transfer
    while(SPI_SR_EOQF != (SPI1_SR & SPI_SR_EOQF));
    SPI1_SR = SPI1_SR | SPI_SR_TCF  | SPI_SR_EOQF ;
    SPI1_MCR |= 0x00000001; // halt
    pop_reg = SPI1_POPR ;  // dummy read
    pop_reg = SPI1_POPR ;  // dummy read
    
    pop_reg = SPI1_POPR ;
    printf("1st word: 0x%04x\r\n", pop_reg);
    pop_reg = SPI1_POPR ;
    printf("2nd word: 0x%04x\r\n", pop_reg);
    
    for(j=0;j<10;j++)
    {  
      SPI1_PUSHR = 0x90010000; // 1st dummy tx fifo
      SPI1_PUSHR = 0x90010000; // 2nd dummy tx fifo
      SPI1_PUSHR = 0x90010000; // 3rd dummy tx fifo
      SPI1_PUSHR = 0x98010000; // 4th dummy tx fifo
      SPI1_MCR &=  0xfffffffe;  // start transfer
      while(SPI_SR_EOQF != (SPI1_SR & SPI_SR_EOQF));
      SPI1_SR = SPI1_SR | SPI_SR_TCF  | SPI_SR_EOQF ;
      SPI1_MCR =  0x84010201; // halt
      
      pop_reg = SPI1_POPR ;
      printf("0x%04x, ", pop_reg);
      pop_reg = SPI1_POPR ;
      printf("0x%04x, ", pop_reg);
      pop_reg = SPI1_POPR ;
      printf("0x%04x, ", pop_reg);
      pop_reg = SPI1_POPR ;
      printf("0x%04x\r\n", pop_reg);
    }
    SPI1_PUSHR = 0x18010000; // last dummy tx fifo
    SPI1_MCR &=  0xfffffffe;  // start transfer
    while(SPI_SR_EOQF != (SPI1_SR & SPI_SR_EOQF));
    SPI1_SR = SPI1_SR | SPI_SR_TCF  | SPI_SR_EOQF ;
    SPI1_MCR |=  0x00000001; // halt    
    pop_reg = SPI1_POPR ; // read 43th word.
    printf("0x%04x\r\n", pop_reg); 
    
    printf("\n DSPI SR register value: %08X \n",SPI1_SR);
    break; 
    
    case DELAY_READ_DATA:
    SPI1_MCR = 0x80010C01; 
    SPI1_CTAR0 = (0x78000000 + dspi_value->br) | dspi_value->cpha | dspi_value->cpol | dspi_value->delay;
    SPI1_PUSHR = 0x80010300; // 1st fifo
    SPI1_CTAR1 = (0x78000000 + dspi_value->br) | dspi_value->cpha | dspi_value->cpol | dspi_value->delay;
    SPI1_PUSHR = 0x90010000; // 2nd fifo
    SPI1_PUSHR = 0x90010000; // 3rd fifo
    SPI1_CTAR0 = (0x78000000 + dspi_value->br) | dspi_value->cpha | dspi_value->cpol | dspi_value->delay;
    SPI1_PUSHR = 0x88010000; // 4th fifo, end of queue
    SPI1_MCR =  0x80010000;  // start transfer
    while(SPI_SR_EOQF != (SPI1_SR & SPI_SR_EOQF));
    SPI1_SR = SPI1_SR | SPI_SR_TCF  | SPI_SR_EOQF ;
    SPI1_MCR =  0x80010001; // halt
    pop_reg = SPI1_POPR ;  // dummy read
    pop_reg = SPI1_POPR ;  // dummy read
    
    pop_reg = SPI1_POPR ;
    printf("1st word: 0x%04x\r\n", pop_reg);
    pop_reg = SPI1_POPR ;
    printf("2nd word: 0x%04x\r\n", pop_reg);
    
    for(j=0;j<10;j++)
    {  
      SPI1_PUSHR = 0x90010000; // 1st dummy tx fifo
      SPI1_PUSHR = 0x90010000; // 2nd dummy tx fifo
      SPI1_PUSHR = 0x90010000; // 3rd dummy tx fifo
      SPI1_PUSHR = 0x98010000; // 4th dummy tx fifo
      SPI1_MCR =  0x80010000;  // start transfer
      while(SPI_SR_EOQF != (SPI1_SR & SPI_SR_EOQF));
      SPI1_SR = SPI1_SR | SPI_SR_TCF  | SPI_SR_EOQF ;
      SPI1_MCR =  0x80010001; // halt
      
      pop_reg = SPI1_POPR ;
      printf("0x%04x, ", pop_reg);
      pop_reg = SPI1_POPR ;
      printf("0x%04x, ", pop_reg);
      pop_reg = SPI1_POPR ;
      printf("0x%04x, ", pop_reg);
      pop_reg = SPI1_POPR ;
      printf("0x%04x\r\n", pop_reg);
    }
    SPI1_PUSHR = 0x18010000; // last dummy tx fifo
    SPI1_MCR =  0x80010000;  // start transfer
    while(SPI_SR_EOQF != (SPI1_SR & SPI_SR_EOQF));
    SPI1_SR = SPI1_SR | SPI_SR_TCF  | SPI_SR_EOQF ;
    SPI1_MCR =  0x80010001; // halt    
    pop_reg = SPI1_POPR ; // read 43th word.
    printf("0x%04x\r\n", pop_reg); 
    
    printf("\n DSPI SR register value: %08X \n",SPI1_SR);    
    break;
    
    case MEM_RDID://read mem id
    SPI1_MCR = 0x80010001;
    SPI1_CTAR0 = (0x78000000 +dspi_value->br) | dspi_value->cpha | dspi_value->cpol;
    SPI1_PUSHR = 0x80019F00;
    SPI1_CTAR1 = (0x78000000 +dspi_value->br) | dspi_value->cpha | dspi_value->cpol;
    SPI1_PUSHR = 0x18010000;    
    SPI1_MCR =  0x80010000 ;  
    while( SPI_SR_EOQF != (SPI1_SR & SPI_SR_EOQF))
    {}
    SPI1_SR = SPI1_SR | SPI_SR_EOQF | SPI_SR_TCF ;
    SPI1_MCR = 0x80010001;
    pop_reg = SPI1_POPR ;    
    printf("Manufacturer ID: %08x\r\n", pop_reg&0xff);
    pop_reg = SPI1_POPR;
    printf("Device ID: %08x\r\n", pop_reg&0xffff);
    break;
  }
	
	
}





