typedef signed char			s8;  /*  8 bits */
typedef signed short int	s16; /* 16 bits */
typedef signed long int		s32; /* 32 bits */


typedef struct {
	uint32 saddr;
	uint16 tcdAttr;
	s16 soff;  
	uint32 nbytes;
	s32 slast;
	uint32 daddr;
	uint16 citer;
	s16 doff;
	s32 dlast_sga;
	uint16 biter;
	uint16 csr;
	int channelno;
	uint32 testdata;
	int loopcount;
    uint32 link;
} dma_tcd ;

enum COMMAND
{
	CONFIG_BASIC_XFR,
	MEM_FILL,
	DMA_SOFT_START,
	XFR_OVER_WAIT,
	CMP_MEM,
	CONFIG_BASIC_XFR_FULL_INT,
	CONFIG_BASIC_XFR_HALF_INT,
	CHK_HALF_POINT,
	MINOR_LOOP_CH_LINK,
	MINOR_LOOP_LINKED_CH_CFG,
	MAJOR_LOOP_LINK_EN,
	TCD_CONFIG,
	SLAST_CHECK,
	DLAST_CHECK,
	SGA_TEST_CONFIG,
	SGA_ENB,
	XFR_WAIT_ERROR_CHECK,
	ERROR_CLR,
	INSERT_CPE_ERR,
	CONFIG_PRIORITY,
	CHECK_PRI
};

struct dummy_tcd {

	uint32 saddr;
	uint16 attr;
	uint16 soff;
	uint32 nbytes;
	uint32 slast;
	uint32 daddr;
	uint16 citer;
	uint16 doff;
	struct edmaTcdType * dlast_sga;
	uint16 biter;
	uint16 csr;
	
} ;

void dma_config(int COMMAND , dma_tcd *tcd_value);
