/*
 * File:		int_handlers.c
 * Purpose:		Interrupt handlers
 *
 */

#include "common.h"
#include "dspi_common.h"

int int_spi_rfdf = 0;
int int_spi_rfof = 0;

/********************************************************************/
void k70_set_handler(int vect, void (*handler)(void))
{
  extern uint32 __VECTOR_RAM[];
  __VECTOR_RAM[vect] = (uint32)handler;
}

/********************************************************************/
extern int dspi_int_count;
void dspi_eoqf_int_handler (void)
{
  printf("EOQF Interrupt handler serviced\n");
  printf("\n SR register value: %08X \n",SPI1_SR);
  
  SPI1_SR = SPI1_SR | SPI_SR_EOQF  ;
  dspi_int_count++;
}
/********************************************************************/

void dspi_tcf_int_handler (void)
{
  printf("TCF Interrupt handler serviced\n");
  printf("\n SR register value: %08X \n",SPI1_SR);
  
  SPI1_SR = SPI1_SR | SPI_SR_TCF  ;
  dspi_int_count++;
}

/********************************************************************/

void dspi_tfff_int_handler (void)
{
  SPI1_RSER = 0x00000000;	  
  
  printf("TFFF Interrupt handler serviced\n");
  printf("\n SR register value: %08X \n",SPI1_SR);
  
  SPI1_SR = SPI1_SR | SPI_SR_TFFF  ;
  dspi_int_count++;
}
/********************************************************************/

void dspi_rfof_int_handler (void)
{
  SPI1_RSER = 0x00000000;	  
  SPI1_SR = SPI1_SR | SPI_SR_RFOF  ;
  int_spi_rfof = 1;
  dspi_int_count++;
  
  printf("RFOF Interrupt handler serviced\n");
  printf("\n SR register value: %08X \n",SPI1_SR);
}
/********************************************************************/

void dspi_rfdf_int_handler (void)
{
  SPI1_RSER = 0x00000000;	  
  SPI1_SR = SPI1_SR | SPI_SR_RFDF  ;
  dspi_int_count++;
  int_spi_rfdf = 1;
  
  printf("RFDF Interrupt handler serviced\n");
  printf("\n SR register value: %08X \n",SPI1_SR);
}
/*********************************************************************/

void dspi_tfuf_int_handler(void)
{
    SPI1_RSER = 0x00000000;	  
    SPI1_SR = SPI1_SR | SPI_SR_TFUF  ;
    dspi_int_count++;
    
    printf("TFUF Interrupt handler serviced\n");
    printf("\n SR register value: %08X \r\n",SPI1_SR);    
}