/*
 * File:		lcdc.h
 * Purpose:		LCD Controller header file
 *
 */

#ifndef __lcdc_H__
#define __lcdc_H__

#include "common.h"

#define FRD43040CA
//#define FRD43040ID
//#define FRD300C4006
//#define FRD500A4001
//#define FRD5040TPT
//#define FRD5040TPTB
//#define FRD7040TPT

#if defined(FRD5040TPT) || defined(FRD7040TPT) 
	#define SCREEN_XSIZE 800
	#define SCREEN_YSIZE 480
#endif

#if defined (FRD500A4001) || defined(FRD5040TPTB) || defined(FRD43040CA) || defined(FRD43040ID)
	#define SCREEN_XSIZE 480
	#define SCREEN_YSIZE 272
#endif

#define GW_XSIZE (SCREEN_XSIZE/2)
#define GW_YSIZE (SCREEN_YSIZE/2)

#define FRAME_START_ADDRESS 0x80400000  //Screen in DDR
#define GW_START_ADDRESS 0x80200000

#define FRAME_BUFFER_SIZE (SCREEN_XSIZE * SCREEN_YSIZE * 4) //4 bytes per pixel for 24bpp
#define GW_BUFFER_SIZE (GW_XSIZE * GW_YSIZE * 4) //4 bytes per pixel for 24bpp

//Amount to add to image address so it points to alias at 0x80xx_xxxx
//  instead of where the linker puts all "code" at 0x08xx_xxxx
#define FRAME_DDR_OFFSET 0x78000000



/* Init Functions */
void lcdc_init_screen();
void lcdc_init_spi_lcd();
void lcdc_init_pins();

/* Color Demo */
void lcdc_test();

#endif /* __lcdc_H__ */