/*****************************************************************************
Filename:
   i2s.h

Author:
   Brian Peterson, Momentum Data Systems, October 2010

Project:


Change log at end of file

******************************************************************************/

#ifndef _SAI_H
#define _SAI_H
/******************************************************************************
* Includes
******************************************************************************/

/******************************************************************************
* Constants
******************************************************************************/
#define SAI_MODE_INT 1
#define SAI_MODE_DMA 2


#ifndef SAI_RUN_UNDER_MQX
  #define SAI_RUN_UNDER_MQX 1
#endif


#ifndef SAI_MODE
  #define SAI_MODE SAI_MODE_DMA
#endif


#ifndef SAI_BUFFER_SIZE
  #define SAI_BUFFER_SIZE 2304 // max buffer size for MP3 PLAYING 16 bit values
#endif

#ifndef SAI_BUFFER_CNT
  #define SAI_BUFFER_CNT 3  // multiply of buffers in row!! thi number will be 2^n
#endif

#define SAI_PORT 0

/******************************************************************************
* Macros 
******************************************************************************/
  
#define SAI_BUFFER_CNT_REAL (1 << SAI_BUFFER_CNT)  // multiply of buffers in row!!
/******************************************************************************
* Types
******************************************************************************/
#ifdef __cplusplus
extern "C" {
#endif
void SAI_FREEBUFFER_EVENT_CB(int ix);

/******************************************************************************
* Global variables
******************************************************************************/
extern void SAI_FreeBufferCB(int ix);

#define SAI_FREEBUFFER_EVENT_CB SAI_FreeBufferCB


/******************************************************************************
* Global functions
******************************************************************************/

void SAI_Init(void);
int SAI_EnableTx(unsigned long currBuffSize);
void SAI_DisableTx(void);
int SAI_SetSampleRate(int smprate);
void SAI_LastBlockLoaded(signed short* pBuffer);
unsigned short* SAI_GetOutBuff(unsigned char ix);
unsigned long SAI_GetOutBuffCnt(void);
void SAI_PauseTx(void);
void SAI_ResumeTx(void);
#ifdef __cplusplus
}
#endif



#endif  // I2S_H
